config/routes.rb
Rails.application.routes.draw do

  devise_for :clients, controllers: {
               registrations: 'clients/registrations'
             }

  get 'operations/check_balance', to: 'operations#check_balance', as: 'check_balance'
  get 'operations/transaction', to: 'operations#transaction', as: 'transaction'
  post 'operations/create_transfer', to: 'operations#create_transfer', as: 'create_transfer'

  root to: 'home#index'
end

app/controllers/operations_controller.rb
class OperationsController < ApplicationController
  def check_balance
  end

  def transaction
    @params = {}
  end

  def create_transfer
    source_id = current_client.account.id
    destination_id = transaction_params[:target]
    amount = transaction_params[:amount]
    @response = CreateTransaction.create(source_id, destination_id, amount)

    if @response.valid?
      flash[:notice] = 'Transferencia realizada com sucesso.'
      redirect_to root_path
    else
      render :transaction
    end
  end


  def transaction_params
    return @params if @params
    @params = params.require(:transfer).permit(:target, :amount)
    @params
  end
end

app/views/operations/_transfer_errors.html.haml
- if @response && @response.invalid?
  .panel.panel-danger
    .panel-heading
      %h3.panel-title= t('operations.views.transfer.title_error')
    .panel-body
      %ul
        - @response.full_messages.each do |msg|
          %li= msg

app/views/operations/check_balance.html.haml
.page-header
  = link_to_back root_path, class: 'pull-right'
  %h3= icon :money, t('operations.views.balance.title')

.row
  .col-sm-12
    %h3
      = t('operations.views.balance.my_balance')
      = humanized_money_with_symbol current_client.account.amount

app/views/operations/transaction.html.haml
.page-header
  %h3= t('operations.views.transfer.title')

= render 'transfer_errors'

.panel.panel-default
  .panel-body
    = form_tag create_transfer_path, class: 'form-horizontal' do
      .form-group
        %label.control-label.col-sm-4= t('operations.transfer.balance')
        .col-sm-8
          %p.form-control-static
            = humanized_money_with_symbol current_client.account.amount

      .form-group
        %label.control-label.col-sm-4= t('operations.transfer.target')
        .col-sm-8
          = text_field_tag 'transfer[target]', @params[:target], class: 'form-control', required: true

      .form-group
        %label.control-label.col-sm-4= t('operations.transfer.amount')
        .col-sm-8
          = text_field_tag 'transfer[amount]', @params[:amount], class: 'form-control money', required: true

      %hr
      = button_tag(type: 'submit', class: 'btn btn-success pull-right') do
        = icon 'arrow-right', t('operations.transfer.submit'), right: true